﻿package com.Islands 
{
	import org.flixel.*;
	
	public class SoundLibrary
	{
		//Music
		[Embed(source = '../../snd/intro.mp3')] private var SndMusic_Intro:Class;
		[Embed(source = '../../snd/activate_checkpoint.mp3')] private var Snd_Activate_Checkpoint:Class;
		[Embed(source = '../../snd/ghost_exists.mp3')] private var Snd_Ghost_Exists:Class;
		[Embed(source = '../../snd/hit_ground.mp3')] private var Snd_Hit_Ground:Class;
		[Embed(source = '../../snd/hurt.mp3')] private var Snd_Hurt:Class;
		[Embed(source = '../../snd/jump.mp3')] private var Snd_Jump:Class;
		[Embed(source = '../../snd/swap_places.mp3')] private var Snd_SwapPlaces:Class;
		[Embed(source = '../../snd/water_recede.mp3')] private var Snd_Water_Recede:Class;
		[Embed(source = '../../snd/win.mp3')] private var Snd_Win:Class;
		
		[Embed(source = '../../snd/island theme.mp3')] private var SndMusic_Theme:Class;
		
		
		protected static var _library:SoundLibrary;
		
		protected static var _sounds:Array;
		protected static var _init:Boolean = false;
		
		protected static var i:uint = 0;
		
		public static const SOUND_MUSIC_INTRO:uint = i++;
		public static const SOUND_ACTIVATE_CHECKPOINT:uint = i++;
		public static const SOUND_GHOST_EXISTS:uint = i++;
		public static const SOUND_HIT_GROUND:uint = i++;
		public static const SOUND_HURT:uint = i++;
		public static const SOUND_JUMP:uint = i++;
		public static const SOUND_SWAP_PLACES:uint = i++;
		public static const SOUND_WATER_RECEDE:uint = i++;
		public static const SOUND_MUSIC_THEME:uint = i++;
		public static const SOUND_WIN:uint = i++;
		
		public function SoundLibrary() 
		{
		}
		
		public static function Initialize():void
		{
			_library = new SoundLibrary();
			
			_sounds = new Array();
			
			_sounds.push(new FlxSound());
			(_sounds[SOUND_MUSIC_INTRO] as FlxSound).loadEmbedded(_library.SndMusic_Intro, true);
			
			_sounds.push(new FlxSound());
			(_sounds[SOUND_ACTIVATE_CHECKPOINT] as FlxSound).loadEmbedded(_library.Snd_Activate_Checkpoint, false);
			
			_sounds.push(new FlxSound());
			(_sounds[SOUND_GHOST_EXISTS] as FlxSound).loadEmbedded(_library.Snd_Ghost_Exists, true);
			
			_sounds.push(new FlxSound());
			(_sounds[SOUND_HIT_GROUND] as FlxSound).loadEmbedded(_library.Snd_Hit_Ground, false);
			
			_sounds.push(new FlxSound());
			(_sounds[SOUND_HURT] as FlxSound).loadEmbedded(_library.Snd_Hurt, false);
			
			_sounds.push(new FlxSound());
			(_sounds[SOUND_JUMP] as FlxSound).loadEmbedded(_library.Snd_Jump, false);
			
			_sounds.push(new FlxSound());
			(_sounds[SOUND_SWAP_PLACES] as FlxSound).loadEmbedded(_library.Snd_SwapPlaces, false);
			
			_sounds.push(new FlxSound());
			(_sounds[SOUND_WATER_RECEDE] as FlxSound).loadEmbedded(_library.Snd_Water_Recede, false);
			
			_sounds.push(new FlxSound());
			(_sounds[SOUND_MUSIC_THEME] as FlxSound).loadEmbedded(_library.SndMusic_Theme, true);
			
			_sounds.push(new FlxSound());
			(_sounds[SOUND_WIN] as FlxSound).loadEmbedded(_library.Snd_Win, false);
			
			_init = true;
		}
		
		public static function PlaySound(index:uint, fadetime:Number = 0):void
		{
			if (!_init)
				Initialize();
				
			if (index >= _sounds.length)
				return;
				
			if (fadetime == 0)
			{
				_sounds[index].stop();
				_sounds[index].play();
			}
			else
				_sounds[index].fadeIn(fadetime);
		}
		
		public static function KeepPlaying(index:uint):void
		{
			if (!_init)
				Initialize();
			if (index >= _sounds.length)
				return;
			if (!(_sounds[index] as FlxSound).playing)
				_sounds[index].play();
		}
		
		public static function StopSound(index:uint, fadetime:Number = 0):void
		{
			if (!_init)
				Initialize();
				
			if (index >= _sounds.length)
				return;
				
			if(fadetime == 0)
				_sounds[index].stop();
			else
			{
				(_sounds[index] as FlxSound).fadeOut(fadetime);
			}
		}
		
		public static function Update():void
		{
			if (!_init)
				Initialize();
				
			for each(var flxs:FlxSound in _sounds)
				flxs.update();
		}
		
	}
}